{-----------------------------------------------------------------------------}
{ Skipping comments and handling compiler options.	   (c) 1989, 1990 YGP }
(*									     *)
(*       '{'    '(*',  EndCh  '}'  '*'    *)
(*       .			     *)
(*         $          *)
(* . 							     *)
(*									     *)
(*****************************************************************************)

    procedure SkipComment(EndCh: char);
      type Classes  = packed array [char] of char;
	   ClassesP = ^Classes;

      var skipped,
	  MakeIncl:  boolean;	   {     include file (compoption) }
	  SvFlags:   byte;
	  SvClasses: pointer;

      (*) segment (*)
      procedure CompOption;
	label again;
	type OptionSymbol = (Option,   define_sy, else_sy,  endif_sy,
			     ifdef_sy, ifndef_sy, ifopt_sy, undef_sy);
	var SvAkw: pointer;
	    OpSy:  OptionSymbol;
	    ch:      char;
	    plus,				      {     '+' }
	    plus_minus: boolean;	      {     '+'  '-' }

	procedure Conditional;
	  var wrk: ShortCard;

	  procedure GetDefName;
	    label again;
	  begin
again:	  case IdSearch(LexS) of
	    EndBuff: begin			     { Source buffer is empty }
	      ReadBuffer; goto again
	    end { when EndBuff };

	    IdentA,
	    Akeyword:			   { Identifier or keyword of class A }
	      if odd(LexS.flags) then begin ReadBuffer; goto again end;

	    else(*):(*)
	      if odd(LexS.flags) and (TxtBuffer[LexS.start] <> #26)
		then begin ReadBuffer; goto Again end
		else begin LexS.index:= LexS.start; Error(3); nm:= ''; end;
	    end { case };
	  insert(chr(succ(length(nm))), nm, 1);
	  end { GetDefName };

	begin { Conditional }
	if SkipSource and (OpSy in [define_sy, undef_sy])
	  then (*) return {*) exit {*};

	case OpSy of
	  define_sy:		  { define symbol for conditional compilation }
	    begin GetDefName;
	    if pos(nm, Defined) <> 0
	      then (*) return {*) exit {*}
	      else if MaxDef < length(defined) + length(nm)
		then error(238)
	      else insert(nm, Defined, 1);
	    end { when define };

	  undef_sy:		{ undefine symbol for conditional compilation }
	    begin GetDefName;
	    wrk:= pos(nm, Defined);
	    if wrk <> 0 then delete(defined, wrk, ord(defined[wrk]));
	    end { when undef };

	  ifopt_sy,
	  ifdef_sy,
	  ifNdef_sy:				    { conditional compilation }
	    begin GetDefName;
	    Inc(CondLevel);
	    if SkipSource then (*) return {*) exit {*};
	    if OpSy = ifopt_sy
	      then begin SkipSource:= true;
		   if (length(nm) <> 1) or	{       }
		      not (ord(nm[1]) - ord('A') in SwitchOps)
		     then begin Error(2); (*) return {*) exit {*}; end;
		   case TxtBuffer[LexS.index] of
		     '+': SkipSource:= not Opt.All[nm[1]];
		     '-': SkipSource:=     Opt.All[nm[1]];
		     else(*):(*) Error(2)
		     end { case };
		   end
	      else begin SkipSource:= pos(nm, Defined) = 0;
		   if OpSy = ifNdef_sy then SkipSource:= not SkipSource;
		   end;
	    if not SkipSource then TrueLevel:= CondLevel;
	    end { when ifdef, ifopt, ifNdef };

	  else_sy:
	    begin
	    if CondLevel <= Ifile[Ilevel].Clevel
	      then begin Error(239); (*) return {*) exit {*}; end;
	    if CondLevel <= TrueLevel + 1
	      then begin SkipSource:= not SkipSource;
		   TrueLevel:= CondLevel - ord(SkipSource);
		   end;
	    end { when else_sy };

	  endif_sy:
	    begin
	    if CondLevel <= Ifile[Ilevel].Clevel
	      then begin Error(239); (*) return {*) exit {*}; end;
	    Dec(CondLevel); Dec(TrueLevel, ord(not SkipSource));
	    SkipSource:= TrueLevel < CondLevel;
	    end { when endif };

	  end { case };
	end { Conditional };


	(*) segment (*)
	procedure GetIfname;
	  label againSP, againNM;
	  var tk:	token;
	      pathNdx,
	      inserted: natural;
	      wrkFile:	file;
	      pathptr:	stringp;
	      fname:	string; 					 (*){*)
	      FlMd:	byte;						    {*}
	begin	      {     include(link) file     }
	  {                 }
	  if InInit or not InDecl then Error(241);		{ Fatal Error }
	  if Ilevel = MaxIncl then error(242);			{ Fatal Error }

	  close(Ifile[succ(Ilevel)].f^);	  { close   Link file }
	  Ifile[Ilevel+1].Fpos:= -1;			    {   Link }
	  (*){*)if IOresult <> 0 then ; 		   {   }

	  with LexS do begin
againSP:    tk:= IdSearch(LexS);
	    if odd(flags) then begin
	      ReadBuffer; goto againSP
	    end { if };

	    case tk of				 {     }
	      InvalidCh: begin
		if TxtBuffer[start] = EndCh then begin (*  }   *)
		  if ch <> 'L' then
		    error(240)
		  else begin
		    InLink:= false; index:= start;
		    (*) return {*) exit {*};
		  end { if };
		end { if };
	      end { when InvalidCh };

	      UserCh: begin
		case TxtBuffer[LexS.start] of
		  #26: begin						{ EOF }
		    EOFfound:= true; LexS.buffsz:= LexS.index; goto againSP;
		  end { when EOF char (^Z) };

		  #13: begin
		    inc(LineCnt); LLineCnt:= LineCnt; goto againSP;
		  end { when EOLN char (CR) };
		end { case };
	      end { when UserCh };
	    end { case };

	    {       (      )}
	    index:= start;	       {     include  }
againNM:		 {          . }
	    inc(index, ScanFor(#13, TxtBuffer, index, buffsz -index));
	    if index = buffsz then begin
	      index:= start + ScanFor(#26, TxtBuffer, start, buffsz -start);
	      if index = buffsz then begin
		ReadBuffer; goto againNM
	      end { if };
	    end { if };

	    {	              }
	    {     ,      }
	    { ()     , .   .  }

	    if 255 < index - start then error(254);		{ fatal error }

	    Move(TxtBuffer[start], fname[1], index - start);
	    fname[0]:= chr(index -start);

            index:= 1;                {       }
	    while index < length(fname) do begin
	      inc(index, ScanFor(EndCh, fname, index, length(fname)-index+1));
	      if (EndCh='}') or (index <length(fname)-1) and
				(fname[index+1]= ')') then
		fname[0]:= chr(index-1)
	      else begin
		inc(index);
	      end { if };
	    end { while };

	    index:= pos(' ', fname); if index <>0 then fname[0]:= chr(index-1);
	    index:= pos(#9, fname);  if index <>0 then fname[0]:= chr(index-1);
	    index:= start + length(fname);		 {   }

	    {     ? }
	    if length(fname) = 0 then
	    if ch <> 'L' then
	      error(240)
	    else begin
	      InLink:= false; index:= start; (*)return{*)exit{*}
	    end  { if };

            WriteFname;  {          }
	    if ch = 'L' then
	      pathptr:= OBJpaths
	    else begin
	      pathptr:= INCpaths
	    end { if };
	    if (pathptr <> nil) and (length(pathptr^) <> 0) then begin
	      pathNdx:= 1;
	      while pathNdx <= length(pathptr^) do begin
		inserted:= 0;
		while pathptr^[pathNdx] <> ';' do begin
		  inc(inserted);
                  insert(pathptr^[pathNdx], fname, inserted);
		  inc(pathNdx);
		end { while };
		(*) reset (wrkFile, fname);
		{*) FlMd:= FileMode; FileMode:= 0;	  (* input file only *)
		    assign(wrkFile, fname); reset(wrkFile, 1);
		    FileMode:= FlMd;					    {*}
		if IOresult = 0 then
		  pathNdx:= length(pathptr^)		  { force while break }
		else begin
		  delete(fname, 1, inserted);
		end { if };
		close(wrkFile); (*){*) if IOresult <> 0 then ; {  }
		inc(pathNdx);
	      end { while };
	    end { if };

	    inc(Ilevel); OpenIfile(fname); dec(Ilevel);{    incl}
	    MakeIncl:= ch = 'I'; InLink:= ch = 'L';
	  end { with };
	end { GetIfname };

      begin { CompOption }
      repeat inc(LexS.index); { index  '$'  ','     }
	SvAkw:= LexS.ClassAkw;	 { preserve class A keywords, and install new }
	LexS.ClassAkw:= CondKW; 		       { keywords for class A }
again:	case IdSearch(LexS) of
	  EndBuff: begin			     { Source buffer is empty }
	    ReadBuffer; goto again
	  end { EndBuff };

	  IdentA,
	  Akeyword: begin		   { Identifier or keyword of class A }
	    if odd(LexS.flags) then begin
	      ReadBuffer; goto again end
	    else begin
	      OpSy:= OptionSymbol(LexS.KeyWordNo);
	    end { if };
	  end { when IdentA, Akeyword };

	  else(*):(*)
	    if odd(LexS.flags) and (TxtBuffer[LexS.start] <> #26)
	      then begin ReadBuffer; goto Again end
	      else begin LexS.index:= LexS.start;
		   Error(2);
		   LexS.ClassAkw:= SvAkw;	   { restore class A keywords }
		   (*) return {*) exit {*}
		   end;
	  end { case };
	LexS.ClassAkw:= SvAkw;			   { restore class A keywords }

	{               }
	{  $         .	      }

	if OpSy <> Option then
	  Conditional		{    option   conditional keyword }
	else begin	    { index     (..  +/-) }
          {     Conditional compilation   compiler options,   }
          {        .             }
          plus:= (length(nm) = 1);                        { plus used as work }
          if SkipSource and plus then (*) return {*) exit {*};
          if not plus then begin Error(2); (*) return {*) exit {*}; end;

          ch:= nm[1];                                    {    }
          plus:= TxtBuffer[LexS.index] = '+';              {     }
          plus_minus:= plus or (TxtBuffer[LexS.index] = '-');

          LexS.start:= LexS.index; {      }

          {      +/- (   I/L     include/link) }
          if not (plus_minus or (ch in ['I', 'L'])) then begin 
            Error(3); (*) return {*) exit {*} 
          end { if };
          if plus_minus then 
            if not (ord(ch) - ord('A') in SwitchOps) then begin 
              Error(2); (*) return {*) exit {*} end
            else begin 
              Opt.All[ch]:= plus; inc(LexS.index);
              bap(LexS.ClassAkw)^[ElseIfPos]:= ord(Opt.ModulaLike) * 5; 
            end { if }
          else begin  {     (*$I ... *)  (*$L ... *) }
            GetIfname; (*) return {*) exit {*};
          end { if };
        end { if };
        with LexS do begin                                      { skip spaces }
          while (TxtBuffer[index] = ' ') and (index < buffsz) do inc(index);
        end { with };
      until TxtBuffer[LexS.index] <> ',';
      end { CompOption };

    begin { SkipComment }
      {   start       '{'   '(*' }
      {  index   .       buff^		^   }

      MakeIncl:= false;
      InComment:= true; 		     {      }

      if (TxtBuffer[LexS.index] = '$') then CompOption;

      dec(LexS.index, ord(Opt.YGP));		   {    }

      SvClasses:= LexS.Classes; SvFlags:= LexS.flags;
      new(ClassesP(LexS.Classes));
      FillChar(ClassesP(LexS.Classes)^, SizeOf(Classes), Class_D);
      ClassesP(LexS.Classes)^[#13]:=   Class_E; 		       { EOLN }
      ClassesP(LexS.Classes)^[#26]:=   Class_E; 			{ EOF }
      ClassesP(LexS.Classes)^[EndCh]:= Class_E; 		   { LastChar }
      LexS.flags:= 0;

      skipped:= false;
      repeat
	case IdSearch(LexS) of
	  EndBuff: begin
	    ReadBuffer;
	  end { EndBuff };

          UserCh: begin
	    case TxtBuffer[LexS.start] of
	      #13: inc(LineCnt);

              #26: begin
	        EOFfound:= true; LexS.buffsz:= LexS.index;
              end { when #26 };

              '}': skipped:= true;

              '*': begin
                if odd(LexS.flags) then
                  ReadBuffer
                else begin
                  skipped:= TxtBuffer[LexS.index] = ')';
                end { if };
              end { when '*' }
            end { case }
          end { when UserCh };
  	end { case };
      until skipped;

      dispose(ClassesP(LexS.Classes));
      LexS.Classes:= SvClasses; LexS.flags:= SvFlags;
      inc(LexS.index, ord(EndCh = '*')); InComment:= false;

      if MakeIncl then begin
        with Ifile[Ilevel] do begin
          Fpos:= Fposition + LexS.index; Lcount:= LineCnt;
        end { with };

        Inc(Ilevel);
        Ifile[Ilevel].Clevel:= CondLevel;
        Fposition:= 0; Lposition:= -1; Eposition:= -1;
        LLineCnt:= 1; LineCnt:= 1;
        LexS.index:= 0; LexS.buffsz:= 0;
      end { if };
    end { SkipComment };

    procedure SkipIt;
      label againstr;
      var ch: char;
	  cr: natural;
    begin
    repeat
      case IdSearch(LexS) of
	InvalidCh: if odd(LexS.flags)	 {         }
		     then ReadBuffer;

	EndBuff:   begin ReadBuffer; end;	     { Source buffer is empty }

	UserCh:    case TxtBuffer[LexS.start] of
		     #26: begin EOFfound:= true;		   { EOF char }
			  LexS.buffsz:= LexS.index;
			  end { when EOF char (^Z) };

		     #13: begin inc(LineCnt); LLineCnt:= LineCnt;
			  end { when EOLN char (CR) };

		     '"', '''':                                 { Skip String }
		       with LexS do
			 begin ch:= TxtBuffer[start]; inc(start);
againstr:
			 index:= start + 1 +	  {    }
				 ScanFor(ch, TxtBuffer, start, buffsz -start);
			 cr:= start +			      {  <cr> }
				 ScanFor(#13, TxtBuffer, start, buffsz -start);
			 if cr < index then index:= cr;  { <CR> before quote? }
			 if buffsz <= index
			   then begin ReadBuffer; goto againstr; end;
			 end { with & when ' " };
		     end { when UserCh };
	IdentA, 				      { Identifier of class A }
	Akeyword:  if odd(LexS.flags)	 {         }
		     then ReadBuffer;

	Ckeyword:  if odd(LexS.flags)	 {         }
		     then ReadBuffer
		     else begin sy:= symbol(ord(comma) -1 + LexS.keywordNo);
			  case sy of { check for single '{' or double '(*' comment}
			    Scomment: SkipComment('}');
			    Dcomment: SkipComment('*');
			    end { case };
			  end { when Ckeyword };
	end { case };
    until not SkipSource;
    end { SkipIt };

{-----------------------------------------------------------------------------}