{-----------------------------------------------------------------------------}
{ Error reporting procedures.				   (c) 1989, 1990 YGP }

  procedure Error(No: integer);
    (*) segment (*)
    procedure DisplayError;                                              (*){*)
      label exit;                                                           {*}
      var CurErrLvl:    ShortCard;
          ch:           char;
          WarningError: boolean;

      (*) segment (*)
      procedure WriteErrLine;
        var SavePos,
            Possible:  LongInt;
            Line:      string;
            nn, n:     integer;

      begin  {             }
        {      '^'.                                   }
        if not Opt.Quiet then write(message, #7);
        SavePos:= FilePos(Ifile[Ilevel].F^);          { Preserve FilePosition }

        Possible:= LPosition -200;          {       }
        if Possible < 0 then Possible:= 0;                  {  200 ch  }
        Seek(Ifile[Ilevel].f^, Possible);
        Line:= '';

        if IOresult = 0 then begin
          BlockRead(Ifile[Ilevel].f^, Line[1], 255, n);
          if IOresult = 0 then begin
            Line[0]:= chr(n);
            if pos(#26, Line) <> 0 then begin           {    EOF }
              n:= pos(#26, Line);
              line[n]:= #13; line[0]:= chr(n);
            end { if };
          end { if };
        end { if };

        n:= succ(LPosition - Possible);
        if n < length(Line) then begin
          nn:= n + ScanFor(#13, Line, n, -n);
          delete(line, 1, nn); dec(n, nn);  { remove part of previous line(s) }
          if (length(line) <> 0) and (line[1] = #10) then begin
            delete(line, 1, 1); dec(n); inc(nn);
          end { if };

          inc(Possible, nn);              {       }
          Seek(Ifile[Ilevel].f^, Possible);
          BlockRead(Ifile[Ilevel].f^, Line[1], 255, n);
          if IOresult = 0 then begin
            Line[0]:= chr(n);
            n:= pred(pos(#13, Line)); nn:= pred(pos(#26, Line));
            if (0 < n) then Line[0]:= chr(n);
            if (0 < nn) and (nn < length(line)) then Line[0]:= chr(nn);
            n:= LPosition - Possible;
            writeln(Line); Line[0]:= chr(n);
            if (n < 0) or (255 < n) then
              write('??? error position not found')
            else begin           {        }
              for nn:= 1 to n do begin
                if Line[nn] <> #9 then Line[nn]:= ' ';
              end { for };
              writeln(line, '^');
            end { if };
          end { if };
        end { if };

        Seek(Ifile[Ilevel].F^, SavePos);              { Restore file position }
        (*){*) if IOresult = 0 then;              {     }
      end { WriteErrLine };

      (*) segment (*)
      procedure WriteMessage(No: integer);                               (*){*)
        label exit;                                                         {*}
        var nerrors: Cardinal;
            wrk: integer;
            f: file;
            fh: record
              YGP:     string[3];                    {     YGP }
              Version: Cardinal;            {    1.00 .. 100 }
              Country: Cardinal;       { what ASCII standard to use (0 - Any) }
              TblCompiler,
              TblRunTime,
              TblIOerrors,
              TxtStart: LongInt;
            end { fh };

            errdesc: record
              errno: integer;
              erroffs: cardinal;
            end { errdesc };

            s: string;

      begin { WriteMessage }
        if (No < 0) then
          write('*** Internal error ***')
        else if No < 256 then begin
          ParamStr(0, s);                               { get compiler's path }
          wrk:= length(s) + ScanFor('\', s, length(s), -length(s));
          if wrk <> 0                       {     }
            then s[0]:= chr(wrk)                             {   }
            else s[0]:= chr(pos(':', s));            {   }
          insert('UniPas.ERR', s, length(s)+1);
          (*) reset(f, s);
          {*) filemode:= 0; assign(f, s); reset(f, 1); {*}
          if IOresult <> 0 then (*) return {*) goto exit {*};
          seek(f, 32); BlockRead(f, fh, sizeof(fh));
          if (IOresult = 0)and(fh.YGP = 'YGP')and(fh.Version = 100) then begin
            seek(f, fh.TblCompiler);
            BlockRead(f, nerrors, 2);
            while (IOresult = 0) and (nerrors <> 0) do begin
              BlockRead(f, errdesc, 4); dec(nerrors);
              if errdesc.errno = No then begin
                nerrors:= 0;                              { force while break }
                seek(f, fh.TxtStart + errdesc.erroffs);
                BlockRead(f, s[0], 1);                          { string size }
                BlockRead(f, s[1], ord(s[0]));              { read the string }
                if IOresult = 0 then write(s);
              end { if };
            end { while };
          end { if };
          (*) {*) close(f); if IOresult <> 0 then ; {*}
        end { if };

  exit:
        if ErrSy <> other_sy then begin
          write('(': 2);
          case ErrSy of
            ident:   write(nm);
            i_const: write(Last.i);
            c_const: write(Last.S^);
          end { case };
          write(')');
        end { if };
        if 240 <= No then begin
          writeln; write('*** Fatal error! Compilation aborted ***');
          UserBreak:= false;
        end { if };
      end { WriteMessage };

    begin { DisplayError }
      if LPosition < 0 then LPosition:= FPosition + LexS.start;
      { New error Position or Fatal error occured }
      if (EPosition <> LPosition) or (242 < No) or (No < 0) then begin
        if (No = 5) and (ga.kind = expr) then begin {  5  6}
          inc(no, ord(ga.kind = expr));{   ,    addr }
          ga.t:= ga.t^.pointedTP;      {      '^' }
          ga.access:= indirect; ga.AIOffs:= 0;       {   ,    }
        end { if };
        CurErrLvl:= 6;                            {     }
        WarningError:= (0 <= No ) and (No < 14);   { 0..13 are Warning Errors }
        if WarningError then begin
          CurErrLvl:= 5; { Warning }
          if No < 13 then CurErrLvl:= 0;
          if not Opt.Warning then begin{ Don't report warning if they are off }
            (*) return {*) goto exit {*};
          end { if };
        end { if };

        if ErrLevel < CurErrLvl then ErrLevel:= CurErrLvl;
        inc(Errors, ord(not WarningError)); inc(Warnings, ord(WarningError));

        writeln; if PrtErr then WriteErrLine;
        write(Ifile[Ilevel].fname, '(', LLineCnt, ')');
        if WarningError
          then write('. Warning ')
          else write('. Error ');
        write(No, ': '); WriteMessage(No); writeln;
        if (240 <= No) or (No < 0) then begin
          ErrLevel:= 7;                    { Fatal Error. Compilation Aborted }
          halt(7);                {       }
        end { if };

        if ErrorWait then begin
          write(message, 'Hit return to continue, ESC to abort!');
          repeat (*) read(message, ch); {*) ch:= readkey; {*}
          until ch in [' ', #13, #27];
          write(message, #13#24);
          if ch = #27 then begin
            halt(ErrLevel);
          end { if };
        end { if };

        WriteFname;
        if not WarningError then EPosition:= LPosition;
      end { if };
  exit:
      LPosition:= -1;
      ErrSy:= other_sy;
    end { DisplayError };

    (*){*)var  IOerr: integer; {*}

  begin { Error }							    (*)
    {*) IOerr:= IOresult;			      (*   *)
    if IOerr <> 0 then begin
      write(#7#10#13'I/O error: ', IOerr, ' !!!'); readln;
    end (* if *);
    {*}
    DisplayError;
  end { Error };

{-----------------------------------------------------------------------------}