{-----------------------------------------------------------------------------}
{ Creating interface of a unit. Symbol table (*.SYM)	   (c) 1989, 1990 YGP }

  (*) segment (*)
  procedure CreateInterface;
    type TypeOffsets = array [0..255] of record
	   UnitNo:  byte;      {      UnitNo    }
	   LastNo:  integer;   {    unit STANDARD,     }
	 end { TypeOffsets };	    { 22.Jun.90 -      ? }

    var CurOffs,
	Ntypes: integer;
	toffs:	^TypeOffsets;
	heap:	pointer;

    procedure PutAlpha((*) const (*) a: alpha);
    begin
      to_code(a, 8);
{$ifdef makeI}
write('"', a, '",');
{$endif}
    end { PutAlpha };

    procedure PutLword(l: longword);
    begin
      to_code(l, 4);
{$ifdef makeI}
write('$', (*){*) lword2str{*}(l), ',');
{$endif}
    end { PutLword };

    procedure PutWord(w: word);
    begin
      to_code(w, 2);
{$ifdef makeI}
write('$', (*){*) word2str{*}(w), ',');
{$endif}
    end { PutWord };

    procedure PutByte(b: byte);
    begin
      to_code(b, 1);
{$ifdef makeI}
write('$', (*){*) byte2str{*}(b), ',');
{$endif}
    end { PutByte };

    procedure CopyFromTemp;
      var wrk: cardinal;
	  descriptor: TmpDesc;
	  cnst: string;
    begin
      wrk:= TempItems;
      if IntfcOnlyU and (wrk <> 0) then
	error(-26)
      else begin
	Seek(TempFile, TempStart + SizeOf(TmpSaveInfo));
      end { if };
      while wrk <> 0 do begin
	dec(wrk);
	BlockRead(TempFile, descriptor, 1); if IOresult <> 0 then error(248);
	if descriptor <> _const_ then
	  error(-25)
	else begin
	  BlockRead(TempFile, cnst, 1); if IOresult <> 0 then error(248);
	  BlockRead(TempFile, cnst[1], length(cnst));
	  to_code(cnst, length(cnst)+1);
	end { if };
      end { while };
    end { CopyFromTemp };

    procedure DumpUnits;
      var lunit: idp;
	  i: integer;
    begin
      {    ,         .  }
      inc(Units^.IdName[0], 32);       { locase first letter of STANDARD unit }
      for i:= 1 to Nunits do begin
	lunit:= Units^.next;				{   STANDARD }
	while lunit <> nil do begin
	  with lunit^.Intface^ do begin
	    if (lunit^.IdClass = UnitId) and
	       (lunit^.Intface^.UnitNo = i) then begin	  { visible unit only }
	      PutAlpha(lunit^.IdName);
	      PutWord(Ver);				   { put unit version }
	      PutWord(Date);			 { put data of used interface }
	      PutWord(Time);			 { put time of used interface }
	       { lowcase first letter to mark already dumped ident, unvisible }
	      inc(lunit^.IdName[0], 32);{ units are not entered in a sequance }
	      lunit:= nil; end
	    else begin
	      lunit:= lunit^.next;
	      if lunit = nil then error(-43);
	    end { if };
	  end { with };
	end { while };
      end { for };
    end { DumpUnits };

    procedure DumpIdentifier(fidp: idp); forward;

    procedure PrepareTypes;
      var lunit, lidp: idp;

      procedure PrepType(fidp: idp);
	var t: typep;
	    wrk: integer;
      begin
	t:= fidp^.IdType; wrk:= t^.TSize;
	if wrk < 0 then begin				     { already dumped }
	  (*) return {*) exit {*};
	end { if };

	inc(Ntypes);
	t^.TSize:= -(fidp^.TypeNo + CurOffs); fidp^.TypeNo:= -wrk;
{$ifdef makeI}
write('[', fidp^.IdName, ' ', fidp^.TypeNo + CurOffs']');
{$endif}
      end { PrepType };

      procedure Sequance(fidp: idp);
      begin
	while fidp <> nil do begin
	  if fidp^.IdClass <> TypeId then error(-40);	    {    }
	  PrepType(fidp);
	  fidp:= fidp^.next;
	end { while };
      end { Sequance };

      var Ucnt: natural;

    begin { PrepareTypes }
      Ntypes:= 0; CurOffs:= 0;	 {       STANDRAD }
      Sequance(Units^.Intface^.ExpTypes); { Standrad     }
      toffs^[0].LastNo:= Ntypes; toffs^[0].UnitNo:= 255;     {  - }
      ucnt:= 1; lunit:= Units^.next;			  { (   255) }
      while lunit <> nil do begin
	if lunit^.IdClass = UnitId then begin
	  CurOffs:= Ntypes; Sequance(lunit^.Intface^.ExpTypes);
	  with toffs^[ (* lunit^.Intface^.UnitNo *) ucnt ] do begin
	    LastNo:= Ntypes; UnitNo:= lunit^.Intface^.UnitNo;
	  end { with };
	  inc(ucnt);
	end { if };
	lunit:= lunit^.next;				  { and get next unit }
      end { while };

      lidp:= ExportTypes; CurOffs:= Ntypes;
      while lidp <> nil do begin
	PrepType(lidp);
	DumpIdentifier(lidp);
	PutByte(ord(lidp^.IdType^.TForm));
	lidp:= lidp^.next;
      end { while };
      PutByte($ff);
    end { PrepareTypes };

    procedure RestoreNames(fidp: idp);
    begin
      while fidp <> nil do begin
	if 'a' <= fidp^.IdName[0] then dec(fidp^.IdName[0], 32);     { upcase }
	fidp:= fidp^.link;
      end { while };
    end { RestoreNames };

    procedure FindType(TNum: integer; var UnitNo, TypeNo: integer);
      var i: integer;
    begin
      TypeNo:= 0; TNum:= abs(TNum);
      if CurOffs < TNum then begin
	TypeNo:= TNum - CurOffs; UnitNo:= 0;		       { current unit }
	(*) return {*) exit {*};
      end { if };

      for i:= 0 to Nunits do begin   {     ,    }
	if TNum <= toffs^[i].LastNo then begin
	  UnitNo:= toffs^[i].UnitNo;
	  if i <> 0 then
	    TypeNo:= TNum - toffs^[i-1].LastNo
	  else begin
	    UnitNo:= 255;
	    TypeNo:= Tnum;
	  end { if };
	  (*) return {*) exit {*};
	end { if };
      end { for };
      error(-29);
    end { FindType };

    procedure DumpVpart(fvarp: varntp);
      var lvarp, lvarp1: varntp;
	  i: Cardinal;				   { to calc common SubVparts }
	  FirstTime: boolean;
    begin
      FirstTime:= true;
      while fvarp <> nil do begin
	with fvarp^ do begin
	  PutByte(ord(not FirstTime)); PutWord(Vsize);
	  if FirstTime then begin			   { Parts = TagField }
	    DumpIdentifier(TagId); fvarp:= LastVpart;
	    lvarp:= fvarp;		     { save to check common SubVparts }
	    FirstTime:= false; end
	  else begin
	    PutWord(VarValue);
	    if (SubVpart = nil) or
	       (SubVpart^.TagId^.IdName[0] < 'a') then
	      DumpVpart(SubVpart)
	    else begin
	      lvarp1:= lvarp; i:= 0;
	      while (lvarp1 <> nil) and ((lvarp1^.SubVpart = nil) or
		    (lvarp1^.SubVpart^.TagId^.IdName <>
		     SubVpart^.TagId^.IdName)) do begin
		inc(i); lvarp1:= lvarp1^.NextVpart;
	      end { while };
	      if lvarp1 = nil then error(-31);
	      PutByte(2); PutWord(i);
	    end { if };
	    fvarp:= NextVpart;
	  end { if };
	end { with };
      end { while };
      PutByte($ff);
    end { DumpVpart };

    procedure DumpType(ftp: typep; sz: integer);
      var lidp: idp;
	  UnitNo, TypeNo: integer;
    begin
      {    'sz'  < 0        .    }
      {    >= 0         TSize-,    }
      {              .     }
      {                }
      {     (.. TSize)   < 0    .	      }

      if ftp = nil then begin	{      NIL,   }
	PutWord(0); PutWord($ffff);		       {   FILE of  }
	(*) return {*) exit {*};
      end { if };

      with ftp^ do begin
	if 0 <= TSize then	      {    (   0  }
	  PutWord(0)	{    UNIT)   unit   }
	else begin				  { Imported or exported type }
	  FindType(TSize, UnitNo, TypeNo); PutWord(TypeNo); PutByte(UnitNo);
	  if sz < 0 then (*) return {*) exit {*};
	end { if };

	if 0 <= sz then    {    ( (SZ < 0) & (TSize < 0) }
	  PutWord(sz)		  {         .. }
	else begin	     {          }
	  PutWord(TSize);			       {   SZ   TSize }
	  PutByte(ord(TForm));	    {  TForm-    }
	end { sz };

	case TForm of
	  Enumerated: begin				   { Enumerated types }
	    lidp:= LastConst; PutWord(lidp^.No);	     {   }
	    while lidp <> nil do begin		{      }
	      PutAlpha(lidp^.IdName); lidp:= lidp^.next;	{  }
	    end { while };
	  end { when enumerated };

	  SubRange, ESubRange: begin { SubRange types & SubRange of enumerated}
	    DumpType(RangeType, -1);
	    PutWord(tmin); PutWord(tmax);      {    LongInt !!! }
	  end { when subrange & enumerated subrange };

	  Pointers: begin				      { Pointer types }
	    DumpType(PointedTp, -1);
	  end { when Pointers };

	  PowerSet: begin					  { Set types }
	    DumpType(BaseType, -1);
	  end { when PowerSet };

	  Arrays, PArrays: begin		 { non packed & packed arrays }
	    DumpType(IndexType, -1); DumpType(AElemType, -1);
	    if TForm = PArrays then begin
	      PutWord(AByteLng);
	    end { if };
	  end { when non packed & packed arrays };

	  Strings: begin					    { strings }
	    PutByte(StrSize);
	  end { when Strings };

	  Records, PRecords: begin		{ non packed & packed records }
	    if TForm = PRecords then PutWord(RByteLng);
	    DumpVpart(VarPart); lidp:= FrstId;
	    while lidp <> nil do begin
	      DumpIdentifier(lidp);
	      lidp:= lidp^.link;
	    end { while };
	    RestoreNames(FrstId);	     {       unit }
	    PutByte($ff);
	  end { when non packed & packed records };

	  Files: begin						      { Files }
	    DumpType(FileType, -1); PutWord(RecBytes);
	  end { when Files };

	else(*):(*)			   { Scalar, Real, Unreslvd & UnTyped }
	  error(-30)				     {      }
	end { case };
      end { with };
    end { DumpType };

    procedure DumpIdentifier(fidp: idp);
      var t: typep;
	  lidp: idp;
    begin						     { DumpIdentifier }
      with fidp^ do begin
	if IdName[0] >= 'a' then begin            { Identifier already dumped }
	  (*) return {*) exit {*};
	end { if };

	if IdClass = ECnstId then begin {        }
	  (*) return {*) exit {*};
	end { if };

	PutByte(ord(IdClass)); PutByte(IdFlags); PutAlpha(IdName);
	DumpType(IdType, -1);

	case IdClass of
	  TypeId: ;		     {       DumpType }

	  VarId: begin				     { variables & parameters }
	    PutWord(IdAddr);
	  end { when VarId };

	  ConstId: begin			   { identifier of a constant }
	    t:= IdType;
	    if t^.TForm < Pointers then
	      PutLWord(IdValue.i)
	    else if t^.TForm = Pointers then
	      PutWord(IdValue.i)	      {       0 }
	    else if t^.TForm = Strings then
	      if idValue.StrPtr^ = '' then
		PutWord($ffff)
	      else begin
		PutWord(idValue.COffs);
	      end { if }
	    else begin
	      error(-32);
	    end { if };
	  end { when ConstId };

	  FieldId: begin		       { identifier of a record field }
	    PutWord(IdOffset);
	    if IdFlags and _packed <> 0 then begin
	      PutWord(StartByte); PutWord(ByteSize);
	    end { if };
	  end { when FieldId };

	  ProcId, FuncId: begin 	   { procedure or function identifier }
	    if IdFlags and _inline <> 0 then begin
	      PutWord(InLineSz); to_code(InLineCode^, InLineSz); end
	    else if IdFlags and _interfaced <> 0 then begin
	      PutByte(pf.num); PutWord(pf.psize); end
	    else begin
	      error(-33);
	    end { if };

	    lidp:= next;				    { Dump parameters }
	    while lidp <> nil do begin
	      DumpIdentifier(lidp); dec(lidp^.IdName[0], 32);  { restore case }
	      lidp:= lidp^.next;
	    end { while };
	    PutByte($ff);
	  end { when ProcId or FuncId };

	else (*):(*) { ECnstId, LabelId, UnitId, UnUnitId }
	  error(-27)
	end { case };

	{ lowcase first letter to mark already dumped identifier }
	inc(IdName[0], 32);
      end { with fidp^ };
    end { DumpIdentifier };

    procedure DumpIds;
      var lidp: idp;
    begin
      lidp:= level^.Idents;
      while lidp <> nil do begin
	DumpIdentifier(lidp);
	lidp:= lidp^.link;
      end { while };
      PutByte($ff);
    end { DumpIds };

    procedure RestoreTypes;
      var lunits, lidp: idp;
	  wrk:	integer;
    begin
      lunits:= nil;
      lidp:= ExportTypes;  {         }
      repeat			   { .    ,   . }
	while lidp <> nil do begin
	  wrk:= lidp^.IdType^.Tsize;
	  if wrk < 0 then begin 	    {       }
	    lidp^.IdType^.TSize:= -lidp^.TypeNo; lidp^.TypeNo:= -wrk;
	  end { if };
	  lidp:= lidp^.next;
	end { while };
	if lunits = nil then
	  lunits:= Units
	else begin
	  repeat lunits:= lunits^.next;
	  until (lunits = nil) or (lunits^.IdClass = UnitId);
	end { if };
	if lunits <> nil then lidp:= lunits^.Intface^.ExpTypes;
      until lunits = nil;
    end { RestoreTypes };

    procedure DumpExportedTypes;
      var lidp: idp;
    begin
      lidp:= ExportTypes;
      while lidp <> nil do begin
	if lidp^.TypeNo < 0 then DumpType(lidp^.IdType, -lidp^.TypeNo);
	lidp:= lidp^.next;
      end { while };
      PutWord($ffff);
    end { DumpExportedTypes };

  begin { CreateInterface }
    mark(heap);
    if LexLevel <> 0 then error(-24);	   {    LexLevel = 0 }
    if Errors <> 0 then (*) return{*) exit{*}; {      }

    IntfcOnlyU:= IntfcOnlyU and (sy = end_sy);

    PutAlpha(level^.proc^.IdName);			     { name of module }
    PutWord(Cver);						    { Version }
    PutWord(CDate);					{ Date of compilation }
    PutWord(CTime);					{ Time of compilation }
    PutWord(dsize);					    { size of globals }
    PutByte(ord(IntfcOnlyU));				{ interface only unit }
    PutByte(Nunits);			{ number of external (imported) units }

    {	       (       }
    {               .  }
    (*) GetMemWords(toffs, succ(Nunits) * WordSizeOf(toffs^[0]));
    {*) GetMem(toffs, succ(Nunits) * SizeOf(toffs^[0])); {    }

    { lowcase first letter to mark already dumped identifier (Unit Name) }
    inc(level^.proc^.IdName[0], 32);

    DumpUnits;						    { Dump used units }

    PutWord(CpoolSz);		  { length of constant pool (large constants) }
    CopyFromTemp;		   { Copy large constants from temporary file }

    PrepareTypes;			       { Prepare exported type idents }
    DumpIds;				      { Dump all exported identifiers }
    DumpExportedTypes;	    { Dump all exported types (  }

    RestoreNames(level^.Idents);	       { Restore all identifier names }
    RestoreTypes;					{ and type structures }
    release(heap);
  end { CreateInterface };

{-----------------------------------------------------------------------------}
