{-----------------------------------------------------------------------------}
{ Miscellaneous procedures & functions. 		   (c) 1989, 1990 YGP }

  procedure SwapCode(src, dest: natural);
    var sz: integer; wrk: bap;
  begin
    {	  ....XXXXXXXYYYYYY  ProcBuff   ....YYYYYXXXXXXX    }
    {		      ^-src  ^dest ^-ipc				      }
    sz:= dest - src;
    if 0 < sz then begin    {        }
      if ipc < MaxCodeSz - sz then begin	 {       }
        move(ProcBuff[src], ProcBuff[ipc], sz);		    {    }
        move(ProcBuff[dest], ProcBuff[src], (ipc - src)); end	     {   }
      else begin
        (*) GetMemWords(wrk, (sz + 1) div 2); {*) GetMem(wrk, sz); {*}
        move(ProcBuff[src], wrk^, sz);		    {      }
        move(ProcBuff[dest], ProcBuff[src], ipc - dest);    {   }
        move(wrk^, ProcBuff[dest+sz], sz);    {      }
        (*) FreeMemWords(wrk, (sz + 1) div 2); {*) FreeMem(wrk, sz); {*}
      end { if };
    end { if };
  end { SwapCode };

  procedure TestSy(fsy: symbol);
  begin
    if sy = fsy then
      insy
    else begin
      Error(ErrorSy[fsy]);
    end { if };
  end { TestSy };

  procedure ErrSkip(ErrNo: integer; fsys: syset);
  begin
    Error(ErrNo);	     { Report error and then skip input symbols until }
    while not (sy in fsys) do begin		   { relevant symbol is found }
      insy;
    end { insy };
  end { ErrSkip };

  procedure err_nil(ErrNo: integer);
  begin
    error(ErrNo);						     {$ifdef Q}
    halt(7);								{$else}
    ga.t:= nil; 						       {$endif}
  end { err_nil};

  procedure EnterId(fidp: idp);
    var lidp, lidp1: idp;
	name: string[8];						 (*){*)
	nme:  alpha;				   {     - }
  begin
    {	         current }
    { level.               }
    {  . ( -        .)      }
    {	      uses .		      }

  {$ifdef UniPas}	{      Turbo  Uni Pascal }

    {  PrtErr    ,      . }

    if QueueSearch(level^.Idents, 4, 6, lidp, fidp^.IdName, $0884) and
       PrtErr then begin
      move(nm, name, SizeOf(name));				{ preserve nm }
      (*){$W-}(*) move(fidp^.IdName, nm[1], 8); nm[0]:= #8;	     { set nm }
      ErrSy:= ident; Error(52); move(name, nm, SizeOf(nm));	 { restore nm }
    end { if };

    if lidp = nil then begin
      fidp^.link:= level^.Idents;
      level^.Idents:= fidp; end
    else begin
      fidp^.link:= lidp^.link;
      lidp^.link:= fidp;
    end { if };

  {$else}      {        Turbo Pascal       }
	       {            }

    lidp:= level^.Idents; lidp1:= nil; nme:= fidp^.IdName;
    while (lidp <> nil) and (lidp^.IdName < nme) do begin
      lidp1:= lidp; lidp:= lidp^.link;
    end { while };
    { now lidp = lidp1^.link }
		   { PrtErr           }
    (*
    if not prterr and (lidp <> nil) and (lidp^.IdName = nme) then
      prterr:= prterr;
    *)
    if (lidp <> nil) and (lidp^.IdName = nme) and PrtErr then begin
      move(nm, name, SizeOf(name));				{ preserve nm }
      nm:= fidp^.IdName;					     { set nm }
      ErrSy:= ident; Error(52); move(name, nm, SizeOf(nm));	 { restore nm }
    end { if };
    fidp^.link:= lidp;
    if lidp1 = nil
      then level^.Idents:= fidp
      else lidp1^.link:= fidp;
  {$endif}
  end { EnterId };

  procedure SearchSection(where: idp; var fidp: idp);
  begin {     nm  where  }
  {$ifdef UniPas }

    if not QueueSearch(where, 4, 6, fidp, nm[1], $0884) then begin
      fidp:= nil;
    end { if };

  {$else}

    while (where <> nil) and (where^.IdName < alpha(addr(nm[1])^)) do begin
      where:= where^.link;
    end { while };

    if (where <> nil) and (where^.IdName = alpha(addr(nm[1])^))    { : }
      then fidp:= where 			   {      }
      else fidp:= nil;				      { nil     }

  {$endif}
  end { SearchSection };
								    {$ifNdef Q}
  function GetProperClass(fIdClass: IdSet): idp;
    var Class: Classes;
  begin
    Class:= TypeId;
    {	  ,	           }
    {  fIdClass = [],   .        }
    {      	Classes  e      }
    {    .					    }
    while not (Class in fIdClass { or fIdClass = UnUnitId}) do begin
      Class:= succ(Class);		      { find first element of a set }
    end { while };
    GetProperClass:= UnDeclared[Class];
  end { GetProperClass };					     {$endif}

  procedure SearchId(fIdClass: IdSet; var fidp: idp; NotQualSearch: boolean);
    label ErrFound, EndSearch;
    var lidp, lunits: idp;
	UnitSrch,
	SecondPass,
	ErReported:   boolean;
	llevel:       LevelRecord;
  begin  {       (fIdClass).    }
  {    (  /PrtErr/)      }
  { ,          .    }

    Undefined:= false; {       }
    SecondPass:= false; 	   {       }
    levelx:= level; ErReported:= false; UnitSrch:= false;
    repeat lunits:= Units;
      repeat
	repeat SearchSection(levelx^.Idents, lidp);
	  if lidp <> nil then begin
	    if lidp^.IdClass in fIdClass then
	      if SecondPass then begin		  {      }
		ErrSy:= ident; {      }
		Error(213); ErReported:= true;	{      , }
		goto ErrFound; end { ..    ''   Unit-. }
	      else begin
		goto EndSearch
	      end { if }
	    else begin	{  ,       - }
	      {    -.       - }
	      {           	 }
	      {  .    idents   . }
	      repeat lidp:= lidp^.link; 	{   o ids }
		SearchSection(lidp, lidp);
	      until (lidp = nil) or (lidp^.IdClass in fIdClass);
	      if lidp <> nil then goto EndSearch;
	      if PrtErr and not SecondPass then begin  {      }
		ErrSy:= ident;		       {         }
		error(211); ErReported:= true;
		goto ErrFound;
	      end { if };
	    end { if };
	  end { if };

	  if SecondPass then
	    if UnitSrch and (lunits^.Intface^.DBLids <> nil) then begin
	      llevel.Idents:= lunits^.Intface^.DBLids;
	      lunits:= lunits^.next; UnitSrch:= false; end
	    else begin
	      UnitSrch:= true;
	      if lunits = nil then
		levelx:= nil
	      else begin
                lunits:= lunits^.next;
                if lunits <> nil then
                  llevel.Idents:= lunits^.Intface^.Idents
                else begin
                  levelx:= nil;
                end { if };
	      end { if };
	    end { if }
	  else begin
	    levelx:= levelx^.PrevLevel;
	  end { if }
	until levelx = nil;
	{     levelx = nil }
	if NotQualSearch and not SecondPass then begin
	  while (lunits <> nil) and (lunits^.IdClass <> UnitId) do begin
	    lunits:= lunits^.next; { skip unvisible }
	  end { while };
	  if lunits <> nil then begin
	    levelx:= lunits^.Intface;
	    lunits:= lunits^.next;
	  end { if };
	end { if };
      until levelx = nil;
      if SecondPass or not PrtErr then goto ErrFound;
      SecondPass:= true;    {           }
      {     unvisible         . }
      levelx:= addr(llevel); llevel.Idents:= Units^.Intface^.Idents;
      UnitSrch:= true;
    until ErReported;

ErrFound:
  {         .         }
    Undefined:= true;		   {    (   fIdClass). }
    levelx:= LastLevel; 				    {    }
    lidp:= nil; 	      { if PrtErr = false and not found => return nil }
    if PrtErr then begin
      if not ErReported then begin
	ErrSy:= ident; error(212);
      end { if };						     {$ifdef Q}
      HALT(7); {  Q        }	{$else}
      lidp:= GetProperClass(fIdClass);				       {$endif}
    end { if };

EndSearch:
    fidp:= lidp;
  end { SearchId };

  procedure QualIdent(fIdClass: IdSet; var fidp: idp);
    label Qualified;
    var lidp, lidp1: idp;
	wlevel: levelp;
	SavePrt: boolean;
  begin 	{ ,  UnitId not in fIdClass   fIdClass <> [] }
  {		   QualIdent          }
  {    QualIdent      .     }
  {           	    -. }
  {         ,    QulIdent }
  {                }
  { 	.      	     QualIdent(...)     }
  { 	          .    }
  {              QualIdent }
  { 	        .   ,  		   }
  { ''            insy,     }
  { ''        ''     , }
  {  QualIdent  insy.					      }
  {	      ''     }
  {    symbol       (.. id.id ).   }
  {	 :        SvQualUnit   }
  { QualIdent   Unit-          }
  {             Unit	    	   }
  { ''      .             nil  }
  {   insy,        symbol         }
  {   Unit-.						      }

    if SvQualUnit <> nil then begin    {       }
      lidp:= SvQualUnit; goto Qualified;		 {    }
    end { if };

    SearchId(fIdClass + [UnitId, UnUnitId], lidp, true);
    if (lidp <> nil) and (lidp^.IdClass in [UnitId, UnUnitId]) then begin
      insy; TestSy(period); SvQualUnit:= lidp;
Qualified:	 {        , .. Pascal }
      if sy = ident then begin
	wlevel:= level; level:= lidp^.Intface;
	SavePrt:= PrtErr; PrtErr:= false;		{ save and set PrtErr }
	SearchId(fIdClass, lidp, false); PrtErr:= SavePrt;
	if Undefined then begin  { not found,       }
	  lidp1:= level^.Idents;			   { save for a while }
	  level^.Idents:= level^.DBLids;
	  SearchId(fIdClass, lidp, false);
	  level^.Idents:= lidp1;				    { restore }
	end { if };
	level:= wlevel; end
      else begin
	error(50);				     {$ifdef Q} HALT(7) {$else}
	lidp:= GetProperClass(fIdClass);
	Undefined:= true;					       {$endif}
      end { if };
    end { if };
    fidp:= lidp;
  end { QualIdent };

  procedure GetBounds(t: typep; var fmin, fmax: LongInt);
  begin 			      { Get bounds of subrange or scalar type }
    fmin:= 0; fmax:= 0; 	   {      } {$ifNdef Q}
    if t = nil then begin
      (*) return{*) exit{*}
    end { if }; 						       {$endif}

    if t = int_t then begin
      fmin:= -32767; fmax:= 32767; end
    else if (t = lint_t) or (t = lwrd_t) then begin
      fmin:= -2147483647; fmax:= 2147483647; end
    else begin
      with t^ do begin
	if TForm <= Enumerated then begin
	  fmin:= 0;
	  if t = char_t then
	    fmax:= 255
	  else if (t = card_t) or (t = wrd_t) then
	    fmax:= 65535
	  else if (TForm = Enumerated) and (LastConst <> nil) then
	    fmax:= LastConst^.No
	  else begin
	    fmax:= 0;
	  end { if }; end
	else if TForm <= ESubRange then begin
	  t:= RangeType;
	  if t = int_t then begin
	    fmin:= integer(tmin); fmax:= integer(tmax); end
	  else begin
	    fmin:= tmin; fmax:= tmax;
	  end { if }
	end { if };
      end { with };
    end { if };
  end { GetBounds };

  procedure CorrectConstType;
  begin
    if {$ifNdef Q} (ga.t <> nil) and {$endif} (ga.kind = cnst) and
       (ga.t^.TForm = Scalar) and (ga.t <> char_t) then begin
      ga.t:= lint_t;
      if 0 <= ga.Aval.i then begin
	if ga.Aval.i <= 255 then
	  ga.t:= scrd_t
	else if ga.Aval.i <= 32767 then
	  ga.t:= ntrl_t
	else if ga.Aval.i <= 65535 then begin
	  ga.t:= card_t;
	end { if }; end
      else if - 128 <= ga.Aval.i then
	ga.t:= sint_t
      else if -32767 <= ga.Aval.i then begin
	ga.t:= int_t;
      end { if };
    end { if };
  end { CorrectConstType };

  function TypeOK(t2: typep): boolean;
    var t1: typep;
  begin
    TypeOK:= true; t1:= ga.t;					    {$ifNdef Q}
    if (t1 = nil) or (t2 = nil) then (*) return() {*) exit {*};        {$endif}
    if (ESubRange < t1^.TForm) or (ESubRange < t2^.TForm) or
       ((t1 = char_t) xor (t2 = char_t)) then begin {  char    }
      error(156 {  216}); (*) return() {*) exit {*};
    end { if };
    GetBounds(t2, ga.amin, ga.amax);			    { ga used as work }
    if Enumerated < t1^.TForm then t1:= t1^.RangeType;
    if Enumerated < t2^.TForm then t2:= t2^.RangeType;		    {$ifNdef Q}
    if (t1 = nil) or (t2 = nil) then (*) return() {*) exit {*};        {$endif}

    if t1^.TForm = t2^.TForm then
      if (t1^.TForm = Scalar) or (t1 = t2) then begin
	if (ga.kind = cnst) and
	   ((ga.Aval.i < ga.amin) or (ga.amax < ga.Aval.i)) then begin
	  if t2 = wrd_t then	{      word  byte }
					 {    $ffff  $ff   and }
	    ga.Aval.i:= word(ga.Aval.i) and word(ga.Amax)
	  else begin
	    error(187)
	  end { if };
	end { if } end
      else begin
	TypeOK:= false
      end { if }
    else begin
      TypeOK:= false;
    end { if }
  end { TypeOK };
                                                               {$ifNdef UniPAS}
  function MinimizeFname(fname: string): string;
    var path, name, ext: string;
  begin
    if length(fname) <= 15 then
      MinimizeFname:= fname
    else begin
      Fsplit(fname, Path, Name, ext);
      if ext = '' then ext:= '.';
      while length(ext) < 4 do begin
        ext:= ext + ' ';
      end { while };
      name:= path + name;
      if length(name) > (3 + 8) then begin
        delete(name, 1, length(name) - (1 + 8));
        insert('...', name, 1);
      end { if };
      MinimizeFname:= name + ext;
    end { if };
  end { MinimizeFname };                                               {$endif}

  procedure WriteFname;
    (*){*) var sz: byte; {*}
  begin
    (*)
    write(message, #13, Ifile[Ilevel].fname: 15, '(', LineCnt:4, ')');
    {*)
    if length(Ifile[Ilevel].fname) <= 15 then
      write(message, #13, Ifile[Ilevel].fname:15)
    else begin
      write(message, #13, MinimizeFname(Ifile[Ilevel].fname): 15);
    end;
    write(message, '(', LineCnt:4, ')');
    {*}
  end { WriteFname };

  (*) segment (*)
  procedure OpenIfile(var fnm: string);
    var DotPos, SlashPos, l: integer;					 (*){*)
	FlMd: byte;							    {*}
  begin
    if MaxIncl < Ilevel then Error(242);	       {     }
    (*) reset (Ifile[Ilevel].F^, fnm);
    {*) FlMd:= FileMode; FileMode:= 0;			  (* input file only *)
	assign(Ifile[Ilevel].F^, fnm); reset(Ifile[Ilevel].F^, 1);
	FileMode:= FlMd;
    {*}
    if IOresult <> 0 then begin
      if Ilevel = 0 then begin
	writeln(' *** Can''t open ', fnm); halt(7); end
      else begin
	last.s:= addr(fnm); ErrSy:= c_const;
	dec(Ilevel); error(250);
      end { if };
    end { if };

    {           -   }
    if sizeof(Ifile[Ilevel].fname) <= length(fnm) then begin	{    }
      l:= length(fnm);				      {    }
      DotPos:= l + ScanFor('.', fnm, l, -l);             {    }
      SlashPos:= l + ScanFor('\', fnm, l, -l);               {   backslash }
      if DotPos < SlashPos then DotPos:= l;	{  . e  \ =>  ext }
      if 3 < l - DotPos then dec(fnm[0], byte(l-DotPos-3));  {  ext > 3 }
      if 9 < DotPos - SlashPos then begin	{  name   > 8 chars }
	delete(fnm, SlashPos+9, DotPos - SlashPos - 9);
      end { if };
      if 3 < SlashPos then begin      {        ... }
        delete(fnm, 1, length(fnm)-(sizeof(Ifile[Ilevel].fname) -1 -3));
	insert('...', fnm, 1);
      end { if };
    end { if };
    Ifile[Ilevel].fname:= fnm; LLineCnt:= 1;
  end { OpenIfile };

  procedure to_temp((*)const {*) var {*} Buffer; Size: Cardinal);
  begin
    if Errors = 0 then begin		  {        }
      BlockWrite(TempFile, Buffer, Size);
      if IOresult <> 0 then Error(248);
    end { if };
  end { to_temp };

  procedure to_code((*)const {*) var {*} Buffer; Size: Cardinal);
  begin
    if Errors = 0 then begin		  {        }
      BlockWrite(CodeFile, Buffer, Size);
      if IOresult <> 0 then Error(248);
    end { if };
  end { to_code };

{-----------------------------------------------------------------------------}