{-----------------------------------------------------------------------------}
{ Compiling Procedure/Function headers. 		   (c) 1989, 1990 YGP }

    procedure ProcFuncDeclarations(fsy: symbol; SegPF: boolean);
      label EndProc;
      var p, ParmList: idp;
	  t:	       typep;
	  HasParms,						    {$ifNdef Q}
	  NotIdent,						       {$endif}
	  forw:        boolean; 		  { proc was forward declared }
	  llev:        LevelRecord;
	  heap:        pointer;
	  ParmBegSys:  syset;
	  StartLine:   cardinal;

      function ParameterList(fsy: syset; var dsize: Natural): idp;
	var dsz, count, lsize: Natural;
	    lsy: symbol;
	    ltp: typep;
	    lidp, lidp1, lidp2, lidp3: idp;

      begin { ParameterList }
      {   Compile the parameters of a procedure or function declaration.      }
      {-----------------------------------------------------------------------}
      { 								      }
      {          :   }
      {   VAR	parameters:          }
      { 	,   .				      }
      {   VALUE parameters:           }
      { 	         ,	  }
      { 	   ,      }
      { 	.           ,  }
      { 	          , }
      { 	           }
      { 	   ,     .     }
      {   CONST parameters:           }
      { 	         ,	  }
      { 	   ,      }
      { 	.          ,  }
      { 	   VALUE       ,}
      { 	   .   CONST        }
      { 	          VALUE    }
      { 	 .					      }
      {   PROC/ 							      }
      {   FUNC	parameters:     ?    .   }
      { 								      }
      {-----------------------------------------------------------------------}

	dsz:= 0; lidp1:= nil; ParameterList:= nil;
	if not (sy in fsy + [lpar]) then ErrSkip(72, fsy + fsys + [lpar]);

	if sy = lpar then begin
	  insy;
          if sy = rpar then begin
            insy; (*) return() {*) exit {*};
          end { if };

	  if not(sy in ParmBegSys)
	    then ErrSkip(72, fsys + [ident, rpar]);

	  {	 There are five classes of parameter: value, variable, const, }
	  {  procedure and function. This while gets each group of parameters }
	  {  up to each semicolon.					      }
	  while sy in ParmBegSys do begin
	    if (sy = proc_sy) or (sy = func_sy) then
	      error(124)
	    else begin		      { VARiable, VALUE and CONST parameters. }
	      lsy:= sy;       { The only difference in treatment between this }
		   { three kind of parms is that they have different IdFlags: }
							{ _byaddr, _nochange. }
	      if lsy in [var_sy, const_sy] then insy;
	      lidp2:= nil; count:= 0;		 { count number of parameters }
	      repeat
		if sy <> ident then
		  error(50)
		else begin
		  new(lidp(*), VarId(*));
		  with lidp^ do begin
		    move(nm[1], IdName, 8);
		    IdType:= nil;
		    next:= lidp2; IdClass:= VarId;
		    if lsy = var_sy then
		      IdFlags:= _byaddr
		    else if lsy = const_sy then
		      IdFlags:= _nochange
		    else begin
		      IdFlags:= 0;
		    end { if };
		  end { with };
		  EnterId(lidp); lidp2:= lidp;
		  inc(count);
		  insy;
		end { if };

		if not(sy in fsys + [comma, colon, semicolon, rpar])
		  then ErrSkip(72, fsys +[comma, colon, semicolon, rpar]);
		test:= sy <> comma;
		if not test then insy;
	      until test;

	      ltp:= {$ifNdef Q} nil {$else} AnyType {$endif};
	      if sy = colon then begin
		insy;
		if sy = file_sy then begin
		  ltp:= file_t; insy; end
		else if sy = ident then begin
		  QualIdent([TypeId], lidp);
		  insy; ltp:= lidp^.IdType; end
		else begin
		  error(50);
		end { if } end { sy = colon }
              else if lsy = ident then { not Var or Const & no type specified }
		error(48)
	      else begin
		ltp:= AnyType;
	      end { if };

	      lsize:= 1;			{ Size of pointer } {$ifNdef Q}
	      if ltp <> nil then				       {$endif}
		if lsy <> var_sy then begin
		  if ltp^.TForm = Files then
		    error(73)
		  else if (ltp^.TForm <= PowerSet) or
			  (ltp^.TSize <= 2) and
			  (ltp^.TForm <> Strings) then begin
		    lsize:= ltp^.Tsize;
		  end { if };
		end { if };

	      inc(dsz, count * lsize);

	      if ltp = str_t then begin       { allow string length specifier }
                if sy in FacBegSys + [minus_sy] then begin
                  TestSy(lbra); Constant(fsys+[rbra]);
                  if ga.t = scrd_t then begin
                    inc(ga.Aval.i, 1 + ord(not odd(ga.Aval.i)));
                    if lsy <> const_sy then begin
                      if 256 = ga.Aval.i then
                        ltp:= mstr_t
                      else begin
                        new(ltp(*), Strings(*));
                        with ltp^ do begin
                          StrSize:= ga.Aval.i-1;
                          TForm:= Strings;
                          TSize:= ga.Aval.i div 2;
                        end { with };
                      end { if };
                    end { if }; end
                  else begin
                    ltp:= mstr_t;
                    {$ifNdef Q} if ga.t <> nil then {$endif} error(55);
                  end { if };
                  TestSy(rbra); end
                else begin
                  case lsy of
                    ident:  ltp:= mstr_t;
                    var_sy: inc(dsz, count);
                  end { case };
                end { if };
	      end { if };

	      if not(sy in fsys + [semicolon, rpar]) then begin
		ErrSkip(46, fsys + [semicolon, rpar]);
              end { if };

	      lidp3:= lidp2; lidp:= nil;
	      while lidp2 <> nil do begin
		lidp:= lidp2;
		lidp2^.IdType:= ltp;
		lidp2:= lidp2^.next;
	      end { while };

	      if lidp <> nil then begin
		lidp^.next:= lidp1; lidp1:= lidp3;
	      end { if };
	    end { if };

	    if sy <> semicolon then begin
              if sy <> rpar then
                error(46);
              end
            else begin
	      insy;
	      if not(sy in fsys + ParmBegSys) then begin
		ErrSkip(50, fsys + [ident, rpar]);
	      end { if };
	    end { if };
	  end { while sy in ParmBegSys };

	  if sy <> rpar then
	    error(46)
	  else begin
	    insy; CheckSy(fsy + fsys);
	  end { if };

	  {        a .        }
	  {   -.					   }
	  dsize:= dsz;			   { dsize is total parameter size }
	  lidp3:= nil; dsz:= 0;
	  while lidp1 <> nil do begin
	    with lidp1^ do begin     { reverse idents and assign addresses }
	      lsize:= 1; ltp:= IdType;
	      if (ltp <> nil) and (ltp^.TForm <> Strings) and
		 (IdFlags and _byaddr = 0) and (ltp <> AnyType) and
		 ((ltp^.TSize <= 2) or (ltp^.TForm = PowerSet)) then begin
		lsize:= ltp^.TSize; end
	      else begin
		if (IdFlags and _nochange <> 0) then begin
		  IdFlags:= IdFlags or _byaddr
		end { if }
	      end { if };
	      if (ltp = str_t) and (IdFlags and _nochange = 0) then inc(dsz);
	      (*             *)
	      (*   .          *)
	      (*   . 				| *)
	      IdAddr:= dsz; inc(dsz, lsize);			  { <---- *}
	      lidp2:= next;  next:= lidp3; lidp3:= lidp1; lidp1:= lidp2;
	    end { with };
	  end { while };

	  if dsz <> dsize then error(-23);
	  ParameterList:= lidp3;
	end { if };
      end { ParameterList };

      procedure CheckParms(fidp1, fidp2: idp);
      begin
	while (fidp1 <> nil) and (fidp2 <> nil) do begin
	  if (fidp1^.IdName  = fidp2^.IdName)  and
	     (fidp1^.IdClass = fidp2^.IdClass) and
	     (fidp1^.IdFlags = fidp2^.IdFlags) and
             ((fidp1^.IdType  = fidp2^.IdType) or
              (fidp1^.IdType = nil) or (fidp2^.idType = nil) or
              (fidp1^.IdType^.TForm = Strings) and
              (fidp2^.IdType^.TForm = Strings) and
              (fidp1^.IdType^.StrSize = fidp2^.IdType^.StrSize)) then begin
	    fidp1:= fidp1^.next;
	    fidp2:= fidp2^.next; end
	  else begin
	    error(71); (*) return {*) exit {*};
	  end { if };
	end { while };
	if fidp1 <> fidp2 then error(71);	   {      nil }
      end { CheckParms };

      procedure GetInLineProc(var Size: Natural; var p: bap);
	var code: packed array [0..255] of byte;
      begin
	Size:= 0; insy;
	while sy in FacBegSys do
	  begin Constant(fsys + [comma, semicolon]);
	  if ga.t <> scrd_t then
	    error(15)
	  else begin
	    code[Size]:= ga.AVal.i;
	    inc(Size);
	  end { if };
	  if sy in FacBegSys then
	    error(49)
	  else if sy = comma then begin
	    insy;
	  end { if }
	end { while };
	TestSy(semicolon); dec(NextProc);
	if NextProc < 2 then NextProc:= 2;   { error recovary, forward inline }
	(*) GetMemWords(p, (Size+1) div 2);
	{*) GetMem(p, Size); {*}
	move(code, p^, Size);
      end { GetInLineProc };

      procedure LinkExternal(p: idp);
	type ExportItem = packed record
	       Name:	alpha; {   8   }
	       Name1:	alpha; {  16       8 }
	       Value:	Word;  { offset in code if relocatable }
	       ExpType: Word;  { bit 15 = constant/relocatable - 1/0 }
	     end { ExportedItem };

	     OBJheader = packed record
	       magic:	  word; 				      { $5aa5 }
	       version:   word; 				       { 0, 1 }
	       Nexported: cardinal;		{  Exported Items (Bsex+) }
	       Nimported: cardinal;	   { must be 0 (nothing to link with) }
	       CodeSize:  cardinal;		      { size of code in bytes }
	       CodeStart: LongInt;			     { offset of code }
	       ExecAddr:  word;       { entry point for execution (must be 0) }
	       LocalVars: cardinal;		  { length of local variables }
	       reserved:  packed array [0..6] of word;
	     end { OBJheader };

	     fptr = ^file;

	var f:	   fptr;
	    i, j:  integer;
	    svPos: LongInt;
	    obj:   OBJheader;
	    item:  ExportItem;

	    ForTemp: packed record
	      td:      TmpDesc;
	      pNO:     byte;
	      offset:  cardinal;
	    end { ForTemp };

      begin
	if not InLink then
	  error(82)
	else begin
	  write('external(': 10, Ifile[Ilevel+1].Fname, ')');
	  f:= fptr(Ifile[Ilevel+1].f);			   {    }
	  Seek(f^, 0);				      { goto begining of file }
	  BlockRead(f^, obj, SizeOf(obj));	      { read in object header }
	  if IOresult <> 0 then error(253);
	  if obj.magic <> swap($5aa5) then begin       { in Negative Byte Sex }
	    error(88); (*) return {*) exit {*}
	  end { if };
          {$ifdef OBJ_Version_Check} {        OBJ}
	  if 1 < cardinal(swap(obj.version)) then begin               { .}
	    error(89); (*) return {*) exit {*}
	  end { if };
          {$endif}
	  if obj.Nimported <> 0 then Error(90);
	  obj.Nexported:= swap(obj.Nexported);
	  while obj.Nexported <> 0 do begin
	    BlockRead(f^, item, sizeof(item));		      { get next item }
	    if IOresult <> 0 then error(253);
	    i:= ScanFor(#0, item.Name, 0, 16);
	    FillChar(item.Name[i], 16 - i, ' ');
	    if p^.IdName = item.Name then begin
	      if 8 < i then error(12);
	      if item.ExpType and $80 <> 0 then error(92);
	      if word(SegStart) = $ffff then begin  {    ? }
		 {         (32 0  ) }
		SegStart:= (FilePos(CodeFile) + 511) div 512;
		Seek(CodeFile, longint(SegStart) * 512);
		dec(SegStart, OKcode);
		fillchar(ProcBuff, sizeof(ProcBuff), #0);
		to_code(ProcBuff, 32);
	      end { if };

	      if Ifile[Ilevel+1].Fpos < 0 then begin	      { must copy OBJ }
		Ifile[Ilevel+1].Fpos:= CodeSize;
		obj.codesize:= swap(obj.codesize);     {    }
		obj.CodeStart:= LongSwap(obj.CodeStart);
		{  relocation item- ? }
		Seek(f^, obj.CodeStart + obj.codesize);

		BlockRead(f^, i, 2); i:= swap(i);	   {   }
		if IOresult <> 0 then error(253);

		if i <> 0 then begin	       {     - }
			  {  Item  5  + 2  heder + 1  end }
		  with ForTemp do begin
		    td:= _relinfo_; pNO:= 0;
		    offset:= 5 * i + 3;  {       }
		    inc(RelctSz, offset);
		  end { with };
		  to_temp(ForTemp, SizeOf(ForTemp)); inc(TempItems);
		  {   relocation   tempfile }
		  move(CodeSize, ProcBuff, 2); ipc:= 2;   { offset in segment }
		  repeat j:= (MaxCodeSz - ipc) div 5;
		    if	i < j then j:= i;
		    dec(i, j); j:= j * 5;
		    BlockRead(f^, ProcBuff[ipc], j); inc(ipc, j);
		    if IOresult <> 0 then error(253);
		    to_temp(ProcBuff, ipc); ipc:= 0;
		  until i = 0;
		  to_temp(i, 1);	       {  0     }
		end { if };

		{       ''-,     }
		Seek(f^, obj.CodeStart);
		while obj.codesize <> 0 do begin
		  if SizeOf(ProcBuff) < obj.codesize
		    then ipc:= SizeOf(ProcBuff)
		    else ipc:= obj.codesize;
		  BlockRead(f^, ProcBuff, ipc);
		  if IOresult <> 0 then error(253);
		  to_code(ProcBuff, ipc); dec(obj.codesize, ipc);
		  inc(CodeSize, ipc);
		end { while };
		{         1 }
		obj.LocalVars:= swap(obj.LocalVars);
		inc(codesize, obj.LocalVars);
		fillchar(ProcBuff, SizeOf(ProcBuff), #0);
		while obj.LocalVars <> 0 do begin
		  if SizeOf(ProcBuff) < obj.LocalVars
		    then ipc:= SizeOf(ProcBuff)
		    else ipc:= obj.LocalVars;
		  to_code(ProcBuff, ipc); dec(obj.LocalVars, ipc);
		end { while };
	      end { if };

	      with ForTemp do begin
		td:= _procoffs_; pNO:= ProcNo;
		offset:= Ifile[Ilevel+1].Fpos + cardinal(swap(item.value));
	      end { with };
	      to_temp(ForTemp, SizeOf(ForTemp)); inc(TempItems);

	      {        0 }
	      svPos:= FilePos(CodeFile);
	      Seek(CodeFile, LongInt(SegStart +OKcode)*512 +32+ForTemp.offset);
	      BlockRead(CodeFile, ipc, 2); (*) {*) if IOresult <> 0 then; {*}
	      if ipc <> 0 then error(120);
	      Seek(CodeFile, svPos);
	      (*) return {*) exit {*};
	    end { if };
	    dec(obj.Nexported);
	  end { while };
	  error(91);
	end { if };
      end { LinkExternal };

      procedure StartNewProc;
	var tsi: ^TmpSaveInfo;
	    dsz: natural;
	    lidp: idp;
      begin
	p^.IdFlags:= p^.IdFlags and (byte($ff) xor _forward);
	NewProc:= true; LastLevel:= level;

	if SegPF then begin  {       }
	  tsi:= addr(ProcBuff); 			   {  temporary file }
	  with tsi^ do begin
	    ProcNxt:= NextProc;     CurProc:= ProcNo;
	    TmpStrt:= TempStart;    TmpItms:= TempItems; SegStrt:= SegStart;
	    CdSize:= CodeSize;	    CpSize:= CpoolSz;	 RlctSz:= RelctSz;
	    TmpPos:= FilePos(TempFile);
	    if SegStart <> $ffff then
	      CdePos:= FilePos(CodeFile) - OKcode * 512
	    else begin
	      CdePos:= 0;
	    end { if };
	  end { with };
	  TempStart:= FilePos(TempFile);
	  to_temp(tsi^, sizeof(tsi^));

	  ProcNo:= 1; NextProc:= 2;
	  SegNo:= NextSeg; inc(NextSeg);
	  if NextSeg = 256 then error(235);		   {   }
	  p^.pf.num:= 1; p^.pf.seg:= SegNo;

	  TempItems:= 0; SegStart:= $ffff;
	  CodeSize:= 0;  CpoolSz:= 0;	   RelctSz:= 0;

	  if InLink then begin
	    InLink:= false;	     { intersegement object links not allowed }
	    close(Ifile[ILevel+1].F^);
	    Ifile[ILevel+1].Fpos:= -1;			    {   Link }
	    (*){*) if IOresult <> 0 then ;		   {   }
	  end { if };

	  write('s': 2, SegNo); end
	else begin
	  if p^.IdClass = ProcId
	    then write('p': 2)
	    else write('f': 2);
	  if (Errors = 0) or (succ(SegNo) = NextSeg) then begin
	    write(ProcNo);	   {        segment }
	  end { if };	   {    -    }
	end { if };
	{---------------------------------------------------------------------}
	{     21.Jun.1990     BUG.      }
	{   (.. non var).        local  }
	{  cell.              }
	{            .	      }
	{---------------------------------------------------------------------}
	dsz:= level^.Proc^.pf.psize;
	if level^.Proc^.IdType <> nil then begin { add func result sz to dsize}
	  inc(dsz, level^.Proc^.IdType^.TSize); 	  { is the address of }
	end { if };				     { function return value. }
	{ Work down the parameter list to store non var parms (calc addresses)}
	lidp:= level^.Proc^.next;   { all params are linked by the next field }
	while lidp <> nil do begin
	  with lidp^ do begin
	    if (IdClass = VarId) and (IdFlags and _byaddr = 0) and
	       {$ifNdef Q} (IdType <> nil) and {$endif}
	       (IdType^.TForm > PowerSet) and
	       ((IdType^.TSize > 2) or (IdType^.Tform = Strings)) then begin
	      { These are large non var parms and must be copied.  ProcInit}
	      IdAddr:= dsz;	     { New address of a large value parameter }
	      Inc(dsz, IdType^.TSize);
	    end { if };
	    lidp:= lidp^.next;
	  end { with };
	end { while };
        dsize:= dsz;           { <---   ,       }
      end { StartNewProc };

    begin { ProcFuncDeclarations }
      writeln;
      StartLine:= LLineCnt;	  {         }
      forw:= false; ParmBegSys:= [ident, const_sy, var_sy, proc_sy, func_sy];
      {$ifNdef Q} NotIdent:= false; {$endif}

      if SegPF then begin
	fsy:= sy;
	if sy in [proc_sy, func_sy] then
	  insy
	else begin
	  if sy <> ident then Error(29);	      { proc or func expected }
	  fsy:= proc_sy;	 {        segment Boza }
	end { if };
        {    -        interface    
            segment.
        if not InPrgrm then begin
          error(9); segPF:= false;
        end { if };
      end { if };

      level^.SaveDS:= dsize; dsize:= 0;   {    dsize }

      if sy = ident then begin	   {       }
	SearchSection(level^.Idents, p);{          }
	if p <> nil then begin		{ ident. Check this is a proc or func }
	  with p^ do begin  { Intrface      interface-  }
		    { Unit-.       Declared. }
	    forw:= ((p^.IdClass = ProcId) and (fsy = proc_sy) or
		    (p^.IdClass = FuncId) and (fsy = func_sy)) and
		   (p^.IdFlags and _forward <> 0);
	    if not forw then
	      error(63) 				   { Already declared }
	    else begin
	      SegPF:= SegPF or (p^.IdFlags and _overlay <> 0);
	      if SegPF then begin
                p^.IdFlags:= p^.IdFlags or _overlay;
	      end { if };
	    end { if };
	  end { with };
	end { if };	   {       forward }

	if not forw then begin		       {     forward }
	  new(p (*), ProcId{/FuncId}(*));
	  with p^ do begin
	    move(nm[1], IdName, 8);
	    IdType:= nil;   pf.psize:= 0;
	    pf.seg:= SegNo; pf.num:= NextProc;
	    IdFlags:= ord(SegPF) * _overlay;
	    if fsy = proc_sy
	      then IdClass:= ProcId
	      else IdClass:= FuncId;
	    if NextProc = 256 then
	      error(232)				{ Too many procedures }
	    else begin
	      inc(NextProc);
	    end { if };
	  end { with };
	  EnterId(p);
	end { if };
	insy; end { sy = ident }
      else begin
	error(50);     {     } {$ifdef Q} halt; {$else}
	NotIdent:= true;      {       undeclared }
	if fsy = proc_sy
	  then p:= UnDeclared[ProcId]
	  else p:= UnDeclared[FuncId];				       {$endif}
      end { if };

      ProcNo:= p^.pf.num; SegNo:= p^.pf.seg;

      inc(LexLevel); fillchar(llev, sizeof(llev), #0);
      with llev do begin
	PrevLevel:= level; LexLev:= LexLevel; LvlKind:= PFlvl; Proc:= p;    (*
	Labels:= nil; Files:= nil; LabelIds:= nil; Idents:= nil;    FILLCHAR *)
      end { with };

      level:= addr(llev); Mark(heap);

      if fsy = proc_sy then begin
	HasParms:= sy = lpar; ParmList:= ParameterList([semicolon], dsize);
	if forw and HasParms then begin
	  CheckParms(p^.next, ParmList);
	  release(heap); dsize:= p^.pf.psize; end
	else if not (forw {$ifNdef Q} or NotIdent {$endif}) then begin
	  p^.next:= ParmList; p^.pf.psize:= dsize;
	end { if }; end { if fsy = proc_sy }
      else begin
	HasParms:= (sy = lpar) or (sy = colon);
	ParmList:= ParameterList([semicolon, colon], dsize);
	if forw and HasParms then begin
	  CheckParms(p^.next, ParmList);
	  release(heap); dsize:= p^.pf.psize; end
	else if not (forw {$ifNdef Q} and NotIdent {$endif}) then begin
	  p^.next:= ParmList; p^.pf.psize:= dsize;
	end { if };
	if sy = colon then begin
	  insy;
	  if sy = ident then begin
	    QualIdent([TypeId], ParmList);		      { ParmList work }
	    t:= ParmList^.IdType;
	    if forw and (t <> p^.IdType) then
	      error(64)
	    else begin						    {$ifNdef Q}
	      if not NotIdent then				       {$endif}
		p^.IdType:= t;
	      if {$ifNdef Q} (t <> nil) and {$endif}
		 (Pointers < t^.TForm) then begin
		error(65);					     {$ifdef Q}
		halt;							{$else}
		p^.IdType:= nil;				       {$endif}
	      end { if };
	    end { if };
	    insy; end { sy = ident }
	  else begin
	    ErrSkip(50, fsys + [semicolon]); {$ifdef Q} halt {$endif}
	  end { if } end
	else if not forw or HasParms then begin
	  error(66);
	end { if };
      end { if };

      TestSy(semicolon); WriteFname; write(message, p^.IdName: 9+LexLevel,#24);
      write(message, #13);
      (*)
      write(Ifile[Ilevel].fname:15,'(',StartLine:4,')',p^.IdName:9+LexLevel);
      {*)
      if length(Ifile[Ilevel].fname) <= 15 then
        write(Ifile[Ilevel].fname:15)
      else begin
        write(MinimizeFname(Ifile[Ilevel].fname): 15);
      end;
      write('(',StartLine:4,')',p^.IdName:9+LexLevel);
      {*}

      if sy = ident then begin	 {       }
	if nm = 'FORWARD' then                      {  : FORWARD }
	  sy:= frwrd_sy
	else if nm = 'CODE' then                                       { CODE }
	  sy:= code_sy
	else if nm = 'EXTERNAL' then begin                         { EXTERNAL }
	  sy:= extrn_sy;
	end { if };
      end { if };

      mark(llev.MarkHeap);
      if forw then begin
	llev.Idents:= nil; ParmList:= p^.next; {    }
	PrtErr:= false;     { .          }
	while ParmList <> nil do begin	{   ParmList   }
	  EnterId(ParmList);
	  ParmList:= ParmList^.next;
	end { while };
	PrtErr:= true;
      end { if };

      new(level); level^:= llev;

      if sy = extrn_sy then begin			{ EXTERNAL procedure? }
	p^.IdFlags:= _external;
	if SegPF then error(70);
	if errors = 0 then
          LinkExternal(p);
        end
      else if sy = code_sy then begin
	if forw then error(69);
	if SegPF then error(70);
	write('inline': 7);
	GetInLineProc(p^.InLineSz, p^.InLineCode);
	p^.IdFlags:= _inline;
	mark(llev.MarkHeap); end	  {      release }
      else if (sy = frwrd_sy) or (not InPrgrm) then begin
	IntfcOnlyU:= false;		     {    proc/func }
	if not InPrgrm and (sy = frwrd_sy) then error(80);
	if forw then begin		   {     forward }
	  if InPrgrm
	    then error(68)
	    else error(67);
	end { if };
	if InPrgrm then begin
	  write('forward': 8);
	  if SegPF then
	    p^.IdFlags:= _forward + _overlay
	  else begin
	    p^.IdFlags:= _forward
	  end { if }; end
	else begin
	  write('interfaced': 11);
	  p^.IdFlags:= _interfaced + _forward;
	end { if }; end
      else begin
	StartNewProc;
	goto EndProc;
      end { if };

      {           (extrn, frwrd, inln) }
      {         . }
      {  header-   frwrd, extrn, inln /.	      }
      if (sy = frwrd_sy) or (sy = extrn_sy) then begin
	insy; TestSy(semicolon);
      end { if };
      CheckSy(fsys);
      release(llev.MarkHeap);
      level:= llev.PrevLevel;
      ProcNo:= level^.Proc^.pf.num;	  {      }
      SegNo:= level^.Proc^.pf.seg;		  {      }
      dec(LexLevel);
      dsize:= level^.SaveDS;
EndProc:
      WriteFname;
      LastLevel:= level;
    end { ProcFuncDeclarations };

{-----------------------------------------------------------------------------}